"use strict";
function functional(render, _props) {
    // we fool compiler here. _props at runtime is a config object in Vue
    // but for better type inference we `assert` it as a plain data object
    // for more info please refer to the helper function `p` in prop.ts
    var props = _props;
    return {
        props: props, render: render, functional: true
    };
}
exports.functional = functional;
function Mixin(parent) {
    var traits = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        traits[_i - 1] = arguments[_i];
    }
    return parent.extend({ mixins: traits });
}
exports.Mixin = Mixin;
var core_1 = require("./core");
exports.Trait = core_1.Component;
